; JOB library for the PROGS SMS C library
;   JOBPick             pick primary window of job to the top of the pile
;   JOBWake             pick primary of job, including a WAKE event
; written by Joachim Van der Auwera for PROGS
; (c) 1994 by PROGS, Professional & Graphical Software, all rights reserved
; started 1 December 1994
        section text
        include win1_inc_qdos_io
        include win1_inc_qdos_ioa
        include win1_inc_keys_err
        include win1_inc_aid_mac
;
con     dc.w    3,'con'
;
; routines to get the current system network node number
job     equ     4               ; job which has to be picked/woken
_JOBPick xsub
        moveq   #0,d0           ; pick
        bra.s   pick
_JOBWake xsub
        moveq   #8,d0           ; wake
pick    move.l  job(sp),d1      ; job id
        regsave d3/d4/d5/d6
        move.l  d0,d4
        move.l  d1,d5
                                ; open a channel
        lea     con(pc),a0
        moveq   #-1,d1          ; for me
        moveq   #ioa.open,d0
        trap    #do.ioa
        move.l  d0,d6
        bne.s   oops
                                ; pick window
        move.l  d4,d2           ; pick/wake
        move.l  d5,d1           ; job to pick/wake
        moveq   #forever,d3     ; timeout
        moveq   #iop.pick,d0    ; pick window (actually job)
        trap    #do.io
        move.l  d0,d6
                                ; close channel
        moveq   #ioa.clos,d0
        trap    #do.ioa
oops
        move.l  d6,d0
        subend
;
        end
