/*
	Standard library file for PROGS SMS C library

	MEMDuplicate handling library

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera, 2 November 1994
*/

#include "mem_h"
#include "err_h"

Error MEMDuplicate(Size size, void *area, void **base)
{
	Error err;
	err=MEMAllocate(size,base); 	/* allocate the memory for the duplicate */
	if (err) return err;			/* oops, error .. */
	return MEMCopy(size,area,*base);/* do the copy */
}
