; NET library for the PROGS SMS C library
;   NETNodeGet          get network node number for this machine
;   NETNodeSet          set network node number for this machine
; written by Joachim Van der Auwera for PROGS
; (c) 1994 by PROGS, Professional & Graphical Software, all rights reserved
; started 1 December 1994
        section text
        include win1_inc_qdos_sms
        include win1_inc_keys_err
        include win1_inc_keys_sys
        include win1_inc_aid_mac
;
; routines to get the current system network node number
param   equ     4               ; string to store result
_NETNodeGet xsub
        move.l  param(sp),a1    ; place to fill in return value
        regsave d2
        moveq   #sms.info,d0    ; get system info
        trap    #do.sms2        ; do it
        moveq   #0,d1           ; clear MSB byte of word
        move.b  sys_nnnr(a0),d1 ; network node number
        move.w  d1,(a1)         ; set return value
        subend
;
; routines to set the current system network node number
_NETNodeSet xsub
        move.w  param(sp),a1    ; new network node number
        regsave d2
        moveq   #err.ipar,d0    ; assume invalid network node number
        move.l  a1,d1           ; copy to d1
        and.w   #$ff00,d1       ; valid netnode number ??
        bne.s   nodei
        moveq   #sms.info,d0    ; get system info
        trap    #do.sms2        ; do it
        move.l  a1,d1
        move.b  d1,sys_nnnr(a0) ; network node number
nodei   subend
;
        end
