; ROUT library for the PROGS SMS C library
;   ROUTCall            call a routine with a ptr to a list of parameters
; written by Joachim Van der Auwera for PROGS
; (c) 1994 by PROGS, Professional & Graphical Software, all rights reserved
; started 7 December 1994
        section text
        include win1_inc_qdos_sms
        include win1_inc_keys_err
        include win1_inc_keys_sys
        include win1_inc_keys_thg
        include win1_inc_aid_mac
;
; call a routine, precautions are taken to prevent register corruption
; (although d7 has to be preserved !!)
rout    equ     4               ; .l address of routine to call
params  equ     8               ; .l pointer to list of parameters
_ROUTCall xsub
        lea     params(sp),a1   ; start of parameters
        bra.s   call
_ROUTCallList xsub
        move.l  params(sp),a1   ; start of parameters
call
        move.l  rout(sp),a0     ; routine to call
        regsave d2-d7/a2-a5
        move.l  (a1)+,d7        ; count of parameters
        move.l  d7,d2           ; need copy of count
        lsl.w   #2,d7           ; number of bytes
        beq.s   none            ; nothing to copy
        adda.w  d7,a1           ; last parameter
        subq.w  #1,d2           ; adjust for dbf
copy    move.l  -(a1),-(sp)     ; copy a parameter
        dbf     d2,copy         ; another ??
none    jsr     (a0)            ; call extension thing
        add.l   d7,sp           ; restore stack
        subend
;
        end
