/*	Standard library file for PROGS SMS C library */

/* The series for tan x involves the Bernoulli numbers which can give
 *	problems in terms of convergence. The simple trig identity involves
 *	two separate series calculations, but accuracy is preserved over all
 *	values of x.
 */

#include "math_h"

double tan(double x)
{
	return (sin(x)/cos(x));
}
