; startup code for an executable which uses the Dynamic Link Library Manager
; for relocation and linking of external routines.
; written by Joachim Van der Auwera for PROGS
; (c) 1994 PROGS, Professional & Graphical Software
; started 10 October 1994
;
        section text
        include 'win1_inc_keys_sys'
        include 'win1_inc_keys_thg'
        include 'win1_inc_keys_err'
        include 'win1_inc_qdos_sms'
;
        xref    _init
;
the_beginning
*        bra.s   start           ; header blanked out - use of MKEXEC assumed
*        dc.l    0
*        dc.w    $4afb
*        dc.w    6,'noname'      ; fill in the jobname here !!!
;
start
        ; start by searching the thing thing
        move.w  sr,d0                    ; all in supervisor mode please
        trap    #0
        move.w  d0,-(sp)

        moveq   #sms.info,d0             ; do get info
        trap    #do.sms2

        move.l  sys_thgl(a0),d0          ; pointer to thing list
        beq.s   thgf_nf                  ; ... none
thgf_look
        move.l  d0,a0
        move.l  (a0),d0                  ; last thing?
        bne.s   thgf_look

        lea     th_name(a0),a3  
        tst.b   (a3)+
        bne.s   thgf_nf                  ; rather a long name
        lea     thg_name+1,a2
        moveq   #0,d0
        move.b  (a2),d0                  ; name length (byte)
thgf_check
        cmpm.b  (a2)+,(a3)+              ; compare name
        dbne    d0,thgf_check
        bne.s   thgf_nf

        move.l  th_thing(a0),a3          ; point to thing
        cmp.l   #thh.flag,thh_flag(a3)   ; check it just in case
        bne.s   thgf_nf
        moveq   #-1,d0
        sub.l   thh_type(a3),d0          ; and type -1
        beq.s   thgf_exit

thgf_nf
        moveq   #err.fdnf,d0
thgf_exit
        move.w  (sp)+,sr
        move.l  8(a3),a3        ; th_entry

        tst.w   d0              ; have we found it ??
        bne.s   kill
        moveq   #-1,d1          ; for myself
        move.l  #'EXEC',d2      ; extension
        moveq   #-1,d3          ; wait forever
        lea     DLLManager(pc),a0
        moveq   #$28,d0         ; SMS.UTHG
        jsr     (a3)            ; do it
        tst.w   d0              ; ok ??
        bne.s   oops

        lea     linkage(pc),a0  ; information to do it all
        move.l  a0,-(sp)        ; store as parameter
        jmp     $18(a1)         ; start program

oops                            ; ... handle all possible errors ...
                                ; ... hey, what can we do ?? ...
kill    move.l  d0,d3           ; error to return
        moveq   #sms.frjb,d0    ; remove
        moveq   #sms.myjb,d1    ; myself
        trap    #do.sms2        ; do it
                                ; and we won't get this far

thg_name dc.w   5,'THING'
DLLManager dc.w 11,'DLL Manager'
linkage dc.l    linkage-the_beginning
        dc.l    _init-the_beginning
        dc.l    bssbase-the_beginning
;
; I don't need this, but apparently the linker does !!
; use this to force linking of syslib
        section data
        xref    _InitSysLib
        dc.l    _InitSysLib-*
;
        section udata
bssbase dc.l    0
;
        end
