/*
	test program for PROGS SMS C library
	test for hot library
	written by Joachim Van der Auwera for PROGS
	(c) 1995 by PROGS, Professional & Graphical Software
*/

#include "win_h"
#include "str_h"
#include "hot_h"

static WindowDescriptor window={300,560,50,00, 6,6, 2,2, 7,0};

void init()
{
	Error err;
	char chr;
	char line[80];
	char line2[100];
	HotType type=HOT_NOP;
	short act;
	Window chid;

	err=WINOpenFull(&window,&chid);

/*	  HOTCreate(); works */

	WINPutString(chid,"start of hot test");
	HOTStuffPut("test HOTStuffPut");
	WINPutString(chid,"put something in stuffer buffer"); WINGet(chid,&chr);

	HOTStuffGet(line,80);
	WINPutString(chid,line);
	HOTStuffGetPrev(line,80);
	WINPutString(chid,line);
	HOTStuffGetPrev(line,80);
	WINPutString(chid,line); WINGet(chid,&chr);

	err=HOTKeyFind("QD",80,line,&type,&chr,&act);
	STRFormatPut(line2,"%d : %s, %d char %d activ %d",err,line,type,chr,act);
	WINPutString(chid,line2);
	err=HOTKeyFind("p",80,line,&type,&chr,&act);
	STRFormatPut(line2,"%d : %s, %d char %d activ %d",err,line,type,chr,act);
	WINPutString(chid,line2);

	err=HOTKeySet("LINEdesign",'l',HOT_EXEC_FILE,NULL);
	STRFormatPut(line2,"EXEC LINEdesign on 'l' %d",err);
	WINPutString(chid,line2);
	err=HOTKeySet("LINEdesign",'L',HOT_STUFF_STRING,NULL);
	STRFormatPut(line2,"KEY LINEdesign on 'L' %d",err);
	WINPutString(chid,line2); WINGet(chid,&chr);

/*	  HOTKill(); works */
	HOTKeyOff("r");
	HOTKeyReset("x",'y');
	HOTKeyRemove("f");
	HOTKeyDo("c");

	WINPutString(chid,"press a key");
	WINGet(chid,&chr);
	WINClose(chid);
}
