/*
	test program for PROGS SMS C library

	test for mutex library

	written by Joachim Van der Auwera for PROGS
	(c) 1996 by PROGS, Professional & Graphical Software
	started 03.01.1996, based on atomic_c
*/

#include "atomic_h"
#include "io_h"
#include "str_h"
#include "rout_h"
#include "net_h"
#include "mutex_h"

#define catch(x) if (err=(x)) return err; else

#define tell(x) IOPutString(chid,x,NULL)

Error atomic1() { SMSBeep(10000,20); while (1); return ERR_OK; }
void atomic2() { SMSBeep(10000,200); }

int params[2]={1,234};

Error init()
{
	Error err;
	Channel chid;
	char line[80], chr;
	MutexHandler *mutex;

	catch( IOOpen("con",OPEN_OVER,&chid) );

	catch( MEMAllocate(sizeof(mutex),&mutex) );
	mutex->MutexRelease=atomic2;
	mutex->mutex=(char *)131072;

	MUTEXCall(mutex,atomic1,0);

	tell("press a key");
	IOGet(chid,&chr);
	return IOClose(chid);
}
