; part of the PROGS SMS C library
;   SYSAllocate         allocate some memory - without ZapRoutines etc. !!
;   SYSRelease          release  some memory - without ZapRoutines etc. !!
; written by Joachim Van der Auwera for PROGS
; (c) 1994 by PROGS, Professional & Graphical Software, all rights reserved
; started 12 October 1994
        section text
        include win1_inc_qdos_sms
        include win1_inc_aid_mac
;
; routines to allocate some memory
length  equ     4               ; .l length
job     equ     8               ; .l owner job id
ret     equ     12              ; .l place for return
OFF     equ     20
_SYSAllocate xsub
        move.l  length(sp),d1   ; size required
        regsave d2-d4/a2/a3
        move.l  OFF+job(sp),d2  ; put jobid where it should be
        moveq   #sms.achp,d0    ; allocate some memory
        moveq   #0,d3           ; clear this just in case (to allow FastRam)
        trap    #do.sms2        ; do it
        tst.l   d0              ; error ?
        bne.s   oopsall         ; yes -> ooops ..
        move.l  OFF+ret(sp),a1  ; place for return
        move.l  a0,(a1)         ; base of requested memory
oopsall subend
;
; release some memory allocated with SYSAllocate
base    equ     4               ; base of area to release
_SYSRelease xsub
        move.l  base(sp),d0     ; base of area
        regsave d2/d3/a2/a3
        beq.s   relfini         ; base is NULL -> nothing to release
        move.l  d0,a0           ; put base in a0
        moveq   #sms.rchp,d0    ; release memory
        trap    #do.sms2        ; do it
relfini subend
;
        end
