; startup code for an executable which uses the Dynamic Link Library Manager
; for relocation and linking of external routines.
; written by Joachim Van der Auwera for PROGS
; (c) 1994 PROGS, Professional & Graphical Software
; started 10 October 1994
;
        section text
        include 'win1_inc_keys_sys'
        include 'win1_inc_keys_thg'
        include 'win1_inc_keys_err'
        include 'win1_inc_qdos_sms'
;
        xref    _init,THINGcall
;
the_beginning
;
        moveq   #-1,d1          ; for myself
        move.l  #'REXT',d2      ; extension
        moveq   #-1,d3          ; wait forever
        lea     DLLManager(pc),a0
        moveq   #$28,d0         ; SMS.UTHG
        bsr     THINGcall       ; do it
        tst.w   d0              ; ok ??
        bne.s   oops

        lea     linkage(pc),a0  ; information to do it all
        move.l  a0,-(sp)        ; store as parameter
        jmp     $18(a1)         ; start program

oops                            ; ... handle all possible errors ...
                                ; ... hey, what can we do ?? ...
kill    rts

thg_name dc.w   5,'THING'
DLLManager dc.w 11,'DLL Manager'
linkage dc.l    linkage-the_beginning
        dc.l    _init-the_beginning
        dc.l    bssbase-the_beginning
;
; I don't need this, but apparently the linker does !!
; use this to force linking of syslib
        section data
        dc.w    0
;
        section udata
bssbase
;
        end
