/*
	test program for PROGS SMS C library
	test for dir library
	written by Joachim Van der Auwera for PROGS
	(c) 1995 by PROGS, Professional & Graphical Software
*/

#include "win_h"
#include "str_h"
#include "dir_h"
#include "io_h"
#include "ctype_h"

static WindowDescriptor window={300,560,50,00, 6,6, 2,2, 7,0};

void init()
{
	Error err;
	char chr;
	char line[80]="";
	DirIterator it;
	FileInfo fi;
	Window chid;

	err=WINOpenFull(&window,&chid);

	WINPutString(chid,"start of dir test - type directory name (blind)");
	IOGetString(chid,line,80);
	DIROpen(line,TRUE,&it,
						   &DIRSieveExtension, "_c;_h",
						   &DIRSieveLengthSmaller, 2000,
						   NULL);

	while(!DIRNext(it,&fi))
	{
		STRFormatPutSafe(line,80,"%-36s %d",fi.name,fi.length);
		WINPutString(chid,line);
	}

	DIRClose(it);

	WINPutString(chid,"press a key");
	WINGet(chid,&chr);
	WINClose(chid);
}
