/*
	test program for PROGS SMS C library
	test for str library
	written by Joachim Van der Auwera for PROGS
	(c) 1994 by PROGS, Professional & Graphical Software
*/

#include "sms_h"
#include "io_h"
#include "str_h"

#define tell(x) IOPutString(chid,x,&sent)

void init()
{
	Error err;
	Channel chid;
	int sent, i, r;
	char line[80], chr;

	err=IOOpen("con",OPEN_OVER,&chid);

	SMSBeep(4000,200);

	err=SMSVersion(line);
	if (err) tell("SMSversion error");
	tell(line);

	for(i=0;i<8;i++)
	{
		SMSRandom(&r);
		STRFormatPut(line,"%d",r);
		tell(line);
	}
	SMSRandomSeed(RANDOM_INIT);
	SMSRandom(&r);
	STRFormatPut(line,"%d",r);
	tell(line);

	tell ("press a key");
	IOGet(chid,&chr);
	IOClose(chid);
}
